﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ImageTransporter
{
    public partial class ImageTransporter : Form
    {
        //マウスの押された位置
        private Point mouseDownPoint = Point.Empty;


        public ImageTransporter()
        {
            InitializeComponent();
        }

        /// <summary>
        /// フォームロード
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ImageTransporter_Load(object sender, EventArgs e)
        {
            ListViewItem lvi = new ListViewItem();
            lvi.ImageIndex = 0;
            listRoot.Items.Add(lvi);

            lvi = new ListViewItem();
            lvi.ImageIndex = 1;
            listRoot.Items.Add(lvi);

            lvi = new ListViewItem();
            lvi.ImageIndex = 2;
            listRoot.Items.Add(lvi);


 
            SetControlSpacing(listRoot, 75, 100);
        }

        // 幅w、高さhのImageオブジェクトを作成
        Image createThumbnail(Image image, int w, int h)
        {
            Bitmap canvas = new Bitmap(w, h);

            Graphics g = Graphics.FromImage(canvas);
            g.FillRectangle(new SolidBrush(Color.White), 0, 0, w, h);

            float fw = (float)w / (float)image.Width;
            float fh = (float)h / (float)image.Height;

            float scale = Math.Min(fw, fh);
            fw = image.Width * scale;
            fh = image.Height * scale;

            g.DrawImage(image, (w - fw) / 2, (h - fh) / 2, fw, fh);
            g.Dispose();

            return canvas;
        }


        /// <summary>
        /// コピー元リストのドラッグ開始イベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listRoot_MouseDown(object sender, MouseEventArgs e)
        {
            //マウスの左ボタンだけが押されている時のみドラッグできるようにする
            if (e.Button == MouseButtons.Left)
            {
                //ドラッグの準備
                ListView lbx = (ListView)sender;
                //ドラッグするアイテムのインデックスを取得する
                var item = lbx.SelectedItems;

                //マウスの押された位置を記憶
                mouseDownPoint = new Point(e.X, e.Y);

                //if (item.Count != 0)
                //{
                //    //ドラッグするアイテムの内容を取得する
                //    //string itemText = (string)lbx.Items[itemIndex];

                //    //ドラッグ&ドロップ処理を開始する
                //    DragDropEffects dde =
                //        lbx.DoDragDrop(item, DragDropEffects.All);

                //    //ドロップ効果がMoveの時はもとのアイテムを削除する
                //    //if (dde == DragDropEffects.Move)
                //    //    lbx.Items.RemoveAt(int.Parse(item.ToString()));
                //}

            }
            else
                mouseDownPoint = Point.Empty;
        }
        private void listRoot_MouseUp(object sender, MouseEventArgs e)
        {
            mouseDownPoint = Point.Empty;
        }

        private void listRoot_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseDownPoint != Point.Empty)
            {
                //ドラッグとしないマウスの移動範囲を取得する
                Rectangle moveRect = new Rectangle(
                    mouseDownPoint.X - SystemInformation.DragSize.Width / 2,
                    mouseDownPoint.Y - SystemInformation.DragSize.Height / 2,
                    SystemInformation.DragSize.Width,
                    SystemInformation.DragSize.Height);
                //ドラッグとする移動範囲を超えたか調べる
                if (!moveRect.Contains(e.X, e.Y))
                {
                    //ドラッグの準備
                    ListView lbx = (ListView)sender;
                    //ドラッグするアイテムのインデックスを取得する
                   
                    //ドラッグするアイテムの内容を取得する
                    //string itemText = (string)lbx.Items[itemIndex];
                    //ドラッグするアイテムのインデックスを取得する
                    var item = lbx.SelectedItems;
                    int itemIndex = lbx.SelectedItems[0].Index;
                    //ドラッグするアイテムの内容を取得する
                    //string itemText = (string)lbx.Items[itemIndex];
                    Image item_image = listRoot.LargeImageList.Images[itemIndex];
                    //ドラッグ&ドロップ処理を開始する
                    DragDropEffects dde =
                            lbx.DoDragDrop(item_image, DragDropEffects.All | DragDropEffects.Link);

                    //ドロップ効果がMoveの時はもとのアイテムを削除する
                    if (dde == DragDropEffects.Move)
                        lbx.Items.RemoveAt(itemIndex);

                    mouseDownPoint = Point.Empty;
                }
            }

        }

        /// <summary>
        /// コピー先のドラッグドロップイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listDest_DragDrop(object sender, DragEventArgs e)
        {
            //var drags = e.Data.GetFormats();

            //var files = (ListView.SelectedListViewItemCollection)e.Data.GetData(typeof(ListView.SelectedListViewItemCollection));

            ListView target = (ListView)sender;
            Bitmap file = (Bitmap)e.Data.GetData(typeof(Bitmap));

            if (listDest.LargeImageList == null)
            {
                listDest.LargeImageList = new ImageList();
                listDest.LargeImageList.ImageSize = new Size(120, 73);
            }

            listDest.LargeImageList.Images.Add(file);
            ListViewItem lvi = new ListViewItem();
            lvi.Text = "";
            lvi.ImageIndex = listDest.Items.Count;
            listDest.Items.Add(lvi);
            SetControlSpacing(listDest, 75, 100);

            //for (int i = 0; i < files.Count; i++)
            //{
            //    var item_index = ((ListViewItem)files[i]).ImageIndex;

            //    var clear_image = CreateAlphaImage(listRoot.LargeImageList.Images[item_index]);

            //    listDest.LargeImageList.Images.Add(clear_image);
               

            //    ListViewItem lvi = new ListViewItem();
            //    lvi.Text = "";
            //    lvi.ImageIndex = listDest.Items.Count;
            //    listDest.Items.Add(lvi);
            //    SetControlSpacing(listDest, 75, 100);
            //    //listRoot.Items.RemoveAt(item_index);
            //}
            
        }

        /// <summary>
        /// コピー先のドラッグで入ってきたイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void listDest_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        /// <summary>
        /// 半透明の画像を生成します。
        /// </summary>
        /// <param name="sourceImage"></param>
        /// <returns></returns>
        public static Image CreateAlphaImage(Image sourceImage)
        {
            int imageWidth = sourceImage.Width;
            int imageHeight = sourceImage.Height;

            // 新しいビットマップを用意
            Bitmap alphaImage = new Bitmap(imageWidth, imageHeight);

            using (Graphics g = Graphics.FromImage(alphaImage))
            {
                // ColorMatrixオブジェクトの作成
                ColorMatrix cm = new ColorMatrix();

                // ColorMatrixの行列の値を変更して、アルファ値が0.5に変更されるようにする
                cm.Matrix00 = 1;
                cm.Matrix11 = 1;
                cm.Matrix22 = 1;
                cm.Matrix33 = 1;//0.5F;
                cm.Matrix44 = 1;

                // ImageAttributesオブジェクトの作成
                ImageAttributes ia = new ImageAttributes();

                // ColorMatrixを設定
                ia.SetColorMatrix(cm);

                // ImageAttributesを使用して画像を描画
                g.DrawImage(sourceImage,
                            new Rectangle(0, 0, imageWidth, imageHeight),
                            0,
                            0,
                            imageWidth,
                            imageHeight,
                            GraphicsUnit.Pixel,
                            ia);
            }

            return alphaImage;
        }

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
        private static extern Int32 SendMessage(IntPtr hwnd, Int32 wMsg, Int32 wParam, Int32 lParam);

        const int LVM_FIRST = 0x1000;
        const int LVM_SETICONSPACING = LVM_FIRST + 53;

        /// <summary>
        /// コントロール間隔を修正します。
        /// </summary>
        /// <param name="control"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void SetControlSpacing(Control control, Int16 x, Int16 y)
        {
            SendMessage(control.Handle, LVM_SETICONSPACING, 0, x * 65536 + y);
            control.Refresh();
        }

        private void listDest_MouseDown(object sender, MouseEventArgs e)
        {
            //マウスの左ボタンだけが押されている時のみドラッグできるようにする
            if (e.Button == MouseButtons.Left)
            {
                //ドラッグの準備
                ListView lbx = (ListView)sender;
                //ドラッグするアイテムのインデックスを取得する
                var item = lbx.SelectedItems;

                //マウスの押された位置を記憶
                mouseDownPoint = new Point(e.X, e.Y);

                //if (item.Count != 0)
                //{
                //    //ドラッグするアイテムの内容を取得する
                //    //string itemText = (string)lbx.Items[itemIndex];

                //    //ドラッグ&ドロップ処理を開始する
                //    DragDropEffects dde =
                //        lbx.DoDragDrop(item, DragDropEffects.All);

                //    //ドロップ効果がMoveの時はもとのアイテムを削除する
                //    //if (dde == DragDropEffects.Move)
                //    //    lbx.Items.RemoveAt(int.Parse(item.ToString()));
                //}

            }
            else
                mouseDownPoint = Point.Empty;
        }

        private void listRoot_DragDrop(object sender, DragEventArgs e)
        {
            //var drags = e.Data.GetFormats();

            //var files = (ListView.SelectedListViewItemCollection)e.Data.GetData(typeof(ListView.SelectedListViewItemCollection));

            ListView target = (ListView)sender;
            Bitmap file = (Bitmap)e.Data.GetData(typeof(Bitmap));


            if (listRoot.LargeImageList == null)
            {
                listRoot.LargeImageList = new ImageList();
                listRoot.LargeImageList.ImageSize = new Size(120, 73);
            }


            listRoot.LargeImageList.Images.Add(file);
            ListViewItem lvi = new ListViewItem();
            lvi.Text = "test";
            lvi.ImageIndex = listRoot.Items.Count;
            listRoot.Items.Add(lvi);
            SetControlSpacing(listRoot, 75, 100);


        

            //for (int i = 0; i < files.Count; i++)
            //{
            //    var item_index = ((ListViewItem)files[i]).ImageIndex;

            //    var clear_image = CreateAlphaImage(listDest.LargeImageList.Images[item_index]);

            //    listRoot.LargeImageList.Images.Add(clear_image);
                
            //    ListViewItem lvi = new ListViewItem();
            //    lvi.Text = "";
            //    lvi.ImageIndex = listRoot.Items.Count;
            //    listRoot.Items.Add(lvi);
            //    SetControlSpacing(listRoot, 75, 100);
            //    //listDest.Items.RemoveAt(item_index);
            //}
        }

        private void listRoot_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void listDest_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseDownPoint != Point.Empty)
            {
                //ドラッグとしないマウスの移動範囲を取得する
                Rectangle moveRect = new Rectangle(
                    mouseDownPoint.X - SystemInformation.DragSize.Width / 2,
                    mouseDownPoint.Y - SystemInformation.DragSize.Height / 2,
                    SystemInformation.DragSize.Width,
                    SystemInformation.DragSize.Height);
                //ドラッグとする移動範囲を超えたか調べる
                if (!moveRect.Contains(e.X, e.Y))
                {
                    //ドラッグの準備
                    ListView lbx = (ListView)sender;
                    //ドラッグするアイテムのインデックスを取得する
                    //ドラッグするアイテムの内容を取得する
                    //string itemText = (string)lbx.Items[itemIndex];
                    //ドラッグするアイテムのインデックスを取得する
                    var item = lbx.SelectedItems;
                    int itemIndex = lbx.SelectedItems[0].Index;

                    Image item_image = listDest.LargeImageList.Images[itemIndex];

                    //ドラッグ&ドロップ処理を開始する
                    DragDropEffects dde =
                            lbx.DoDragDrop(item_image, DragDropEffects.All | DragDropEffects.Link);
                  //  lbx.DoDragDrop(item, DragDropEffects.All | DragDropEffects.Link);

                    //ドロップ効果がMoveの時はもとのアイテムを削除する
                    if (dde == DragDropEffects.Move)
                        lbx.Items.RemoveAt(itemIndex);

                    mouseDownPoint = Point.Empty;
                }
            }
        }

        private void listDest_MouseUp(object sender, MouseEventArgs e)
        {
            mouseDownPoint = Point.Empty;
        }
    }
}
